<?php

namespace CBapp\Dao;

use \CBapp\Controller\ControllerWshop as ControllerWshop;
use \CBapp\Interfaces\InterfaceConn as InterfaceConn;

class DaoWshop
{
   private $db;
   private $stmt;

   public function __construct(InterfaceConn $db)
   {
       $this->db = $db->connect();
   }

   public function create($bundle)
   {
      $function = $bundle['request']['function'];
      switch ($function){

         case 'apiCreateClientLocal':

         $client = $bundle['request']['client'];

         $dtcadastro = date('Y-m-d H:i:s');

               if(strlen($client['cdchamada']) > 11):
                  $client['nrincrest_rg'] = $client['inscestadual'];
                  $stpessoa = 'Jurídica';
                  $tpcontribuinte = 1;
               else:
                  $client['nrincrest_rg'] = $client['rg'];
                  $stpessoa = 'Física';
                  $tpcontribuinte = 3;
               endif;

               $dataCreate =
               [
                  'idpessoa'           => $client['idpessoa'],
                  'cdempresa'          => $client['cdempresa'],
                  'cdchamada'          => $client['cdchamada'],
                  'nmpessoa'           => mb_strtoupper($client['nmpessoa']),
                  'nmfantasia'         => mb_strtoupper($client['nmfantasia']),
                  'nrincrest_rg'       => $client['nrincrest_rg'],
                  'nrinscrmun'         => $client['nrinscrmun'],
                  'nmendereco'         => mb_strtoupper($client['nmendereco']),
                  'nrlogradouro'       => mb_strtoupper($client['nrlogradouro']),
                  'dscomplemento'      => mb_strtoupper($client['dscomplemento']),
                  'nmbairro'           => mb_strtoupper($client['nmbairro']),
                  'nmcep'              => mb_strtoupper($client['nmcep']),
                  'nmcidade'           => mb_strtoupper($client['nmcidade']),
                  'iduf'               => mb_strtoupper($client['iduf']),
                  'email'              => strtolower($client['email']),
                  'nrpager'            => $client['nrpager'],
                  'nrcodpager'         => $client['nrcodpager'],
                  'nrtelefone'         => $client['nrtelefone'],
                  'nrtelcomercial'     => $client['nrtelcomercial'],
                  'stpermissoes'       => $client['phones'],
                  'stpessoa'           => $stpessoa,
                  'dtcadastro'         => $dtcadastro,
                  'stativo'            => 'S',
                  'tpcontribuinte'     => $tpcontribuinte,
                  'idbairro'           => $client['idbairro'],
                  'idcidade'           => $client['idcidade'],
                  'nrcgc_cic'          => $client['nrcgc_cic'],
                  'sttipopessoa'       => 'C',
                  'stconvenio'         => 'f',
                  'diavencimento'      => '1',
                  'stcontribicms'      => 'f',
                  'praticadescchk'     => 'f',
                  'stusardesccliusu'   => 'f',
                  'stexp'              => 'a'
               ];

               
            \BEGIN_TRANSACTION;
            $sql = " INSERT INTO wshop.pessoas (idpessoa, cdempresa, cdchamada, nmpessoa, nmfantasia, nrincrest_rg, nrinscrmun, nmendereco, nrlogradouro, dscomplemento, nmbairro, nmcep, nmcidade, iduf, email, nrpager, nrcodpager, nrtelefone, nrtelcomercial, stpermissoes, stpessoa, dtcadastro, stativo, tpcontribuinte, idbairro, idcidade, nrcgc_cic, sttipopessoa, stconvenio, diavencimento, stcontribicms, praticadescchk, stusardesccliusu, stexp)
            VALUES (:idpessoa, :cdempresa, :cdchamada, :nmpessoa, :nmfantasia, :nrincrest_rg, :nrinscrmun, :nmendereco, :nrlogradouro, :dscomplemento, :nmbairro, :nmcep, :nmcidade, :iduf, :email, :nrpager, :nrcodpager, :nrtelefone, :nrtelcomercial, :stpermissoes, :stpessoa, :dtcadastro, :stativo, :tpcontribuinte, :idbairro, :idcidade, :nrcgc_cic, :sttipopessoa, :stconvenio, :diavencimento, :stcontribicms, :praticadescchk, :stusardesccliusu, :stexp)";
            $stmt = $this->db->prepare($sql);
            $stmt->execute($dataCreate); 
            $result = $stmt->rowCount();   
            \FINAL_TRANSACTION;

            if($result):
               $client['dao_response_local']['status_create'] = true;
               return $client;
            else:
               $client['dao_response_local']['status_create'] = false;
               return $client;
            endif;

         break;

      }

   }

   public function retrieve($bundle)
   {

      $function = $bundle['request']['function'];
         switch ($function) {

            case 'apiWsGetListFiscal':

                  //header('Content-Type: application/json');
                  //header( 'HTTP/1.1 200 Ok' );
                  //print_r(json_encode($bundle));die;

                  \BEGIN_TRANSACTION;
                  $sql = "SELECT iddocumento, vltotal FROM wshop.documen AS d

                  WHERE d.dtemissao = :dtemissao
                  /*AND d.idpessoa = :idpessoa*/
                  /* AND d.usuario = '" . "$" . "user" . "'*/
                  AND d.tpoperacao = 'V'            /*** (V) = VENDA ***/
                  /***AND d.stdocumentocancelado != '*'  (*) = CANCELADO ***/
                  AND d.idsituacaodoc = '1'         /*** (3) = CANCELADO ***/
                  AND LENGTH(d.usuariodecancelamento) = 0
                  AND LENGTH(d.iddocestorno) = 0
                  AND d.iddocumento NOT IN (SELECT x.iddocestorno FROM wshop.documen AS x WHERE x.idpessoa = d.idpessoa )

                  ";

                  $stmt = $this->db->prepare($sql);
                  $stmt->bindValue(":dtemissao", $bundle['request']['dtemissao']);
                  /*$stmt->bindValue(":idpessoa", $bundle['request']['idpessoa']);
                  $stmt->bindValue(":idpessoa", $bundle['request']['idpessoa']);*/
                  $stmt->execute();
                  $countIddoc = $stmt->rowCount();
                  $bundle['dao_response']['documen'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
                  \FINAL_TRANSACTION;


                  foreach ($bundle['dao_response']['documen'] as $i => $iddoc) {
      
                     $sql = "SELECT nrnotafiscal
                     FROM wshop.documento_nfce AS nfce
                     WHERE iddocumento = :iddocumento
                     AND statusnfce = :statusnfce
                     ";

                     \BEGIN_TRANSACTION;
                     $stmt = $this->db->prepare($sql);
                     $stmt->bindValue(":iddocumento", $iddoc['iddocumento']);
                     $stmt->bindValue(":statusnfce", 'RA');
                     $stmt->execute();
                     $countNfce = $stmt->rowCount();
                     if($countNfce > 0){
                        $nfce = $stmt->fetch(\PDO::FETCH_COLUMN);
                        $bundle['dao_response']['documen'][$i]['nfce'] = $nfce;
                     } else {
                        $bundle['dao_response']['documen'][$i]['nfce'] = 0;
                     }
                     \FINAL_TRANSACTION;                                    

                     $sql = "SELECT nrnotafiscal
                     FROM wshop.documento_nfe AS nfe
                     WHERE iddocumento = :iddocumento
                     AND statusnfe = :statusnfe
                     ";

                     \BEGIN_TRANSACTION;
                     $stmt = $this->db->prepare($sql);
                     $stmt->bindValue(":iddocumento", $iddoc['iddocumento']);
                     $stmt->bindValue(":statusnfe", 'RA');
                     $stmt->execute();
                     $countNfe = $stmt->rowCount();
                     if($countNfe > 0){
                        $nfe = $stmt->fetch(\PDO::FETCH_COLUMN);
                        $bundle['dao_response']['documen'][$i]['nfe'] = $nfe;
                     } else {
                        $bundle['dao_response']['documen'][$i]['nfe'] = 0;
                     }
                     \FINAL_TRANSACTION;

                     /** Wshop get data Item 
                     * =========================================================================
                     * -----------------------------------------------------------------------*/
                     \BEGIN_TRANSACTION;
                     /* ======================================================================== */
                     $sql = "SELECT         
                     /* ================================================ */
                     /* |    Wshopp Scheme     |     CBapp Scheme      | */
                     /* ================================================ */                  
                        cp.dscodigo            /*   dscodigo             */
                     /* ================================================ */
                     FROM wshop.docitem AS i

                     INNER JOIN wshop.produto AS p ON (p.idproduto = i.idproduto)
                     INNER JOIN wshop.grupo   AS g ON (g.idgrupo   = p.idgrupo)
                     INNER JOIN wshop.detalhe AS d ON (d.iddetalhe = i.iddetalhe)
                     INNER JOIN wshop.familia AS f ON (f.idfamilia = d.idfamilia)
                     INNER JOIN wshop.codigos AS cp ON (cp.idproduto = p.idproduto and cp.tpcodigo = 'Personalizado')
                     INNER JOIN wshop.cplitem AS c ON (c.iddocumentoitem = i.iddocumentoitem)
                     
                     WHERE i.iddocumento = :iddocumento LIMIT 1;";
                     /* =========================================================== */               
                     $stmt = $this->db->prepare($sql);
                     $stmt->bindValue(":iddocumento", $iddoc['iddocumento']);
                     $stmt->execute();
                     $item = $stmt->fetch(\PDO::FETCH_COLUMN);
                     \FINAL_TRANSACTION;
                     $bundle['dao_response']['documen'][$i]['item'] = $item;
                     /** ------------------------------------------------------------------------
                     * ========================================================================*/

                  }

                  return $bundle['dao_response'];


                  //header('Content-Type: application/json');
                  //header( 'HTTP/1.1 200 Ok' );
                  //print_r(json_encode($return));die;


            break;

            case 'apiWsGetTotalFiscalSelected':
            
               foreach ($bundle['request']['iddocumento'] as $i => $iddoc) {

                  \BEGIN_TRANSACTION;
                  $sql = "SELECT 
                        iddocumento,
                        idpessoa,
                        cdempresa,
                        dtemissao,
                        cdespecie,
                        cdseriesubserie,
                        nrdocumento,
                        stdocumentocancelado,
                        tpdocumento,
                        usuario,
                        idnfe,
                        vltotal,
                        idsituacaodoc,
                        tpoperacao,
                        idterminal,
                        hrreferencia
                        
                        FROM wshop.documen AS d

                        WHERE d.iddocumento = :iddocumento
                     ";

                     $stmt = $this->db->prepare($sql);
                     $stmt->bindValue(":iddocumento", $iddoc);
                     $stmt->execute();
                     $countIddoc = $stmt->rowCount();
                     $bundle['dao_response']['documen'][$i] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
                     \FINAL_TRANSACTION;                  
      
                        $sql = "SELECT

                        idnfce,
                        iddocumento,
                        nrnotafiscal,
                        serie,
                        chaveacesso,
                        statusnfce,
                        cdretorno,
                        dsretorno,
                        protocolo,
                        dtemissao,
                        cfop,
                        vltotal,
                        vldesconto

                        FROM wshop.documento_nfce AS nfce
                        WHERE iddocumento = :iddocumento
                        AND statusnfce = :statusnfce
                        ";
      
                        \BEGIN_TRANSACTION;
                        $stmt = $this->db->prepare($sql);
                        $stmt->bindValue(":iddocumento", $iddoc);
                        $stmt->bindValue(":statusnfce", 'RA');
                        $stmt->execute();
                        $countNfce = $stmt->rowCount();
                        if($countNfce > 0){
                           $bundle['dao_response']['nfce'][$i] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
                        } else {
                           $bundle['dao_response']['nfce'] = 0;
                        }
                        \FINAL_TRANSACTION;                                    
      
                        $sql = "SELECT 

                        idnfe,
                        iddocumento,
                        nrnotafiscal,
                        serie,
                        chaveacesso,
                        statusnfe,
                        cdretorno,
                        dsretorno,
                        protocolo,
                        dtemissao,
                        cfop,
                        vltotal,
                        vldesconto 

                        FROM wshop.documento_nfe AS nfe
                        WHERE iddocumento = :iddocumento
                        AND statusnfe = :statusnfe
                        ";
      
                        \BEGIN_TRANSACTION;
                        $stmt = $this->db->prepare($sql);
                        $stmt->bindValue(":iddocumento", $iddoc);
                        $stmt->bindValue(":statusnfe", 'RA');
                        $stmt->execute();
                        $countNfe = $stmt->rowCount();
                        if($countNfe > 0){
                           $bundle['dao_response']['nfe'][$i] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
                        } else {
                           $bundle['dao_response']['nfe'] = 0;
                        }
                        \FINAL_TRANSACTION;

                        /** Wshop get data Item 
                        * =========================================================================
                        * -----------------------------------------------------------------------*/
                        \BEGIN_TRANSACTION;
                        /* ======================================================================== */
                        $sql = "SELECT         
                        /* ================================================ */
                        /* |    Wshopp Scheme     |     CBapp Scheme      | */
                        /* ================================================ */
                        i.iddocumentoitem,     /*   iddocumentoitem      */
                        i.iddocumento,         /*   iddocumento          */
                        i.iddetalhe,           /*   iddetalhe            */
                        i.idoperacao,          /*   idoperacao           */
                        i.idproduto,           /*   idproduto            */
                        p.idgrupo,             /*   idgrupo              */
                        p.cdchamada,           /*   cdchamada            */
                        c.dsitemcomplementar,  /*   dsitemcomplementar   */
                        p.nmproduto,           /*   nmproduto            */
                        g.cdgrupo,             /*   cdgrupo              */
                        g.nmgrupo,             /*   nmgrupo              */
                        d.idfamilia,           /*   idfamilia            */
                        f.dsfamilia,           /*   dsfamilia            */
                        i.qtitem,              /*   qtitem               */
                        i.vlitem,              /*   vlitem               */
                        i.vlcusto,             /*   vlcusto              */
                        i.vlunitario,          /*   vlunitario           */
                        i.vlmovimento,         /*   vlmovimento          */
                        cp.dscodigo,           /*   dscodigo             */
                        i.vldesconto           /*   vldesconto           */
                        /* ================================================ */
                        FROM wshop.docitem AS i

                        INNER JOIN wshop.produto AS p ON (p.idproduto = i.idproduto)
                        INNER JOIN wshop.grupo   AS g ON (g.idgrupo   = p.idgrupo)
                        INNER JOIN wshop.detalhe AS d ON (d.iddetalhe = i.iddetalhe)
                        INNER JOIN wshop.familia AS f ON (f.idfamilia = d.idfamilia)
                        INNER JOIN wshop.codigos AS cp ON (cp.idproduto = p.idproduto and cp.tpcodigo = 'Personalizado')
                        INNER JOIN wshop.cplitem AS c ON (c.iddocumentoitem = i.iddocumentoitem)
                        
                        WHERE i.iddocumento = :iddocumento";
                        /* =========================================================== */                  
                        $stmt = $this->db->prepare($sql);
                        $stmt->bindValue(":iddocumento", $iddoc);
                        $stmt->execute();
                        $bundle['dao_response']['item'][$i] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
                        \FINAL_TRANSACTION;
                        /** ------------------------------------------------------------------------
                        * ========================================================================*/
               }
                  if($countNfce > 0 || $countNfe > 0){
                     $bundle['status_return'] = true;
                  } else {
                     $bundle['status_return'] = false;
                  }
                  return $bundle;

            break;

            case 'apiWsGetTotalFiscal':

               \BEGIN_TRANSACTION;
               $sql = "SELECT sum(cast(d.vltotal AS NUMERIC(10,2)))
                     FROM wshop.documen AS d

                     WHERE d.dtemissao = :dtemissao
                     AND d.idpessoa = :idpessoa
                     /* AND d.usuario = '" . "$" . "user" . "'*/
                     AND d.tpoperacao = 'V'            /*** (V) = VENDA ***/
                     /***AND d.stdocumentocancelado != '*'  (*) = CANCELADO ***/
                     AND d.idsituacaodoc = '1'         /*** (3) = CANCELADO ***/
                     AND LENGTH(d.usuariodecancelamento) = 0
                     AND LENGTH(d.iddocestorno) = 0
                     AND d.iddocumento NOT IN (SELECT x.iddocestorno FROM wshop.documen AS x WHERE x.idpessoa = :idpessoa )
                     AND d.iddocumento NOT IN('0100981L5Y', '06001OJG4U')
               ";

               $stmt = $this->db->prepare($sql);
               $stmt->bindValue(":dtemissao", $bundle['request']['dtemissao']);
               $stmt->bindValue(":idpessoa", $bundle['request']['idpessoa']);
               $stmt->bindValue(":idpessoa", $bundle['request']['idpessoa']);
               $stmt->execute();
               $bundle['dao_response']['value_total'] = $stmt->fetchAll(\PDO::FETCH_COLUMN);        
               \FINAL_TRANSACTION;

               \BEGIN_TRANSACTION;
               $sql = "SELECT 
                     iddocumento,
                     idpessoa,
                     cdempresa,
                     dtemissao,
                     cdespecie,
                     cdseriesubserie,
                     nrdocumento,
                     stdocumentocancelado,
                     tpdocumento,
                     usuario,
                     idnfe,
                     vltotal,
                     idsituacaodoc,
                     tpoperacao,
                     idterminal,
                     hrreferencia
                     
                     FROM wshop.documen AS d

                     WHERE d.dtemissao = :dtemissao
                     AND d.idpessoa = :idpessoa
                     /* AND d.usuario = '" . "$" . "user" . "'*/
                     AND d.tpoperacao = 'V'            /*** (V) = VENDA ***/
                     /***AND d.stdocumentocancelado != '*'  (*) = CANCELADO ***/
                     AND d.idsituacaodoc = '1'         /*** (3) = CANCELADO ***/
                     AND LENGTH(d.usuariodecancelamento) = 0
                     AND LENGTH(d.iddocestorno) = 0
                     AND d.iddocumento NOT IN (SELECT x.iddocestorno FROM wshop.documen AS x WHERE x.idpessoa = :idpessoa )
                     AND d.iddocumento NOT IN('0100981L5Y', '06001OJG4U')
               ";

               $stmt = $this->db->prepare($sql);
               $stmt->bindValue(":dtemissao", $bundle['request']['dtemissao']);
               $stmt->bindValue(":idpessoa", $bundle['request']['idpessoa']);
               $stmt->bindValue(":idpessoa", $bundle['request']['idpessoa']);
               $stmt->execute();
               $countIddoc = $stmt->rowCount();
               $bundle['dao_response']['documen'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               \FINAL_TRANSACTION;

               if($countIddoc > 0){

                  foreach ($bundle['dao_response']['documen'] as $i => $iddoc) {
   
                     $sql = "SELECT

                     idnfce,
                     iddocumento,
                     nrnotafiscal,
                     serie,
                     chaveacesso,
                     statusnfce,
                     cdretorno,
                     dsretorno,
                     protocolo,
                     dtemissao,
                     cfop,
                     vltotal,
                     vldesconto

                     FROM wshop.documento_nfce AS nfce
                     WHERE iddocumento = :iddocumento
                     AND statusnfce = :statusnfce
                     ";
   
                     \BEGIN_TRANSACTION;
                     $stmt = $this->db->prepare($sql);
                     $stmt->bindValue(":iddocumento", $iddoc['iddocumento']);
                     $stmt->bindValue(":statusnfce", 'RA');
                     $stmt->execute();
                     $countNfce = $stmt->rowCount();
                     if($countNfce > 0){
                        $bundle['dao_response']['nfce'][$i] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
                     } else {
                        $bundle['dao_response']['nfce'] = 0;
                     }
                     \FINAL_TRANSACTION;                                    
   
                     $sql = "SELECT 

                     idnfe,
                     iddocumento,
                     nrnotafiscal,
                     serie,
                     chaveacesso,
                     statusnfe,
                     cdretorno,
                     dsretorno,
                     protocolo,
                     dtemissao,
                     cfop,
                     vltotal,
                     vldesconto 

                     FROM wshop.documento_nfe AS nfe
                     WHERE iddocumento = :iddocumento
                     AND statusnfe = :statusnfe
                     ";
   
                     \BEGIN_TRANSACTION;
                     $stmt = $this->db->prepare($sql);
                     $stmt->bindValue(":iddocumento", $iddoc['iddocumento']);
                     $stmt->bindValue(":statusnfe", 'RA');
                     $stmt->execute();
                     $countNfe = $stmt->rowCount();
                     if($countNfe > 0){
                        $bundle['dao_response']['nfe'][$i] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
                     } else {
                        $bundle['dao_response']['nfe'] = 0;
                     }
                     \FINAL_TRANSACTION;

               /** Wshop get data Item 
               * =========================================================================
               * -----------------------------------------------------------------------*/
               \BEGIN_TRANSACTION;
               /* ======================================================================== */
               $sql = "SELECT         
                  /* ================================================ */
                  /* |    Wshopp Scheme     |     CBapp Scheme      | */
                  /* ================================================ */
                     i.iddocumentoitem,     /*   iddocumentoitem      */
                     i.iddocumento,         /*   iddocumento          */
                     i.iddetalhe,           /*   iddetalhe            */
                     i.idoperacao,          /*   idoperacao           */
                     i.idproduto,           /*   idproduto            */
                     p.idgrupo,             /*   idgrupo              */
                     p.cdchamada,           /*   cdchamada            */
                     c.dsitemcomplementar,  /*   dsitemcomplementar   */
                     p.nmproduto,           /*   nmproduto            */
                     g.cdgrupo,             /*   cdgrupo              */
                     g.nmgrupo,             /*   nmgrupo              */
                     d.idfamilia,           /*   idfamilia            */
                     f.dsfamilia,           /*   dsfamilia            */
                     i.qtitem,              /*   qtitem               */
                     i.vlitem,              /*   vlitem               */
                     i.vlcusto,             /*   vlcusto              */
                     i.vlunitario,          /*   vlunitario           */
                     i.vlmovimento,         /*   vlmovimento          */
                     cp.dscodigo,           /*   dscodigo             */
                     i.vldesconto           /*   vldesconto           */
                  /* ================================================ */
                     FROM wshop.docitem AS i

                     INNER JOIN wshop.produto AS p ON (p.idproduto = i.idproduto)
                     INNER JOIN wshop.grupo   AS g ON (g.idgrupo   = p.idgrupo)
                     INNER JOIN wshop.detalhe AS d ON (d.iddetalhe = i.iddetalhe)
                     INNER JOIN wshop.familia AS f ON (f.idfamilia = d.idfamilia)
                     INNER JOIN wshop.codigos AS cp ON (cp.idproduto = p.idproduto and cp.tpcodigo = 'Personalizado')
                     INNER JOIN wshop.cplitem AS c ON (c.iddocumentoitem = i.iddocumentoitem)
                     
                     WHERE i.iddocumento = :iddocumento";
                  /* =========================================================== */
                  
               $stmt = $this->db->prepare($sql);
               $stmt->bindValue(":iddocumento", $iddoc['iddocumento']);
               $stmt->execute();
               $bundle['dao_response']['item'][$i] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               \FINAL_TRANSACTION;
               /** ------------------------------------------------------------------------
                  * ========================================================================*/

                  }
                  $bundle['dao_response']['status_fiscal'] = true;
               } else {
                  $bundle['dao_response']['status_fiscal'] = false;
                  $bundle['dao_response']['value_total'] = 0;
                  $bundle['dao_response']['iddocumento'] = 0;
                  $bundle['dao_response']['item'] = 0;
                  $bundle['dao_response']['nfce'] = 0;
                  $bundle['dao_response']['nfe'] = 0;
               }
               
               return $bundle['dao_response'];

            break;

            case 'apiWshopListSales':

               \BEGIN_TRANSACTION;
               $sql = "SELECT sum(cast(d.vltotal AS NUMERIC(10,2)))
                     FROM wshop.documen AS d

                     INNER JOIN wshop.pessoas AS p ON (d.idpessoa = p.idpessoa)

                     WHERE d.dtemissao = '" . $bundle['request']['date'] . "'
                     /* AND d.usuario = '" . "$" . "user" . "'*/
                     AND d.tpoperacao = 'V'            /*** (V) = VENDA ***/
                     /***AND d.stdocumentocancelado != '*'  (*) = CANCELADO ***/
                     AND d.idsituacaodoc = '1'         /*** (3) = CANCELADO ***/
                     AND LENGTH(d.usuariodecancelamento) = 0
                     AND LENGTH(d.iddocestorno) = 0

                  ";

                  $stmt = $this->db->prepare($sql);
                  $stmt->execute();
                  $valueTotal = $stmt->fetchAll(\PDO::FETCH_COLUMN);        
                  \FINAL_TRANSACTION;

                  \BEGIN_TRANSACTION;
                  $sql = "SELECT
                     d.iddocumento, p.nmpessoa, p.nmbairro, p.nrtelefone, p.nrtelcomercial, d.usuario,
                     cast(d.vltotal AS NUMERIC(10,2))

                     FROM wshop.documen AS d

                     INNER JOIN wshop.pessoas AS p ON (d.idpessoa = p.idpessoa)

                     WHERE d.dtemissao = '" . $bundle['request']['date'] . "'
                     /* AND d.usuario = '" . "$" . "user" . "'*/
                     AND d.tpoperacao = 'V'            /*** (V) = VENDA ***/
                     /***AND d.stdocumentocancelado != '*'  (*) = CANCELADO ***/
                     AND d.idsituacaodoc = '1'         /*** (3) = CANCELADO ***/
                     AND LENGTH(d.usuariodecancelamento) = 0
                     AND LENGTH(d.iddocestorno) = 0

                     ";

               $stmt = $this->db->prepare($sql);
               $stmt->execute();
               $bundle['dao_response']['sales'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               $bundle['dao_response']['row_count'] = $stmt->rowCount();
               $bundle['dao_response']['date'] = $bundle['request']['date'];
               $bundle['dao_response']['value_total'] = $valueTotal[0];
               $arraySales = $bundle['dao_response']['sales'];
               \FINAL_TRANSACTION;

               foreach ($arraySales as $i => $sale) {    

                     $sql = "SELECT vd.nmpessoa
                           FROM wshop.documen AS d                    
                           INNER JOIN wshop.comitem AS c ON (d.iddocumento = c.iddocumento) 
                           INNER JOIN wshop.pessoas AS vd ON (c.idpessoa = vd.idpessoa)    
                           WHERE d.iddocumento = :iddocumento
                     ";

                     \BEGIN_TRANSACTION;
                     $stmt = $this->db->prepare($sql);
                     $stmt->bindValue(":iddocumento", $sale['iddocumento']);
                     $stmt->execute();
                     $seller = $stmt->fetchAll(\PDO::FETCH_ASSOC);
                     \FINAL_TRANSACTION;

                     foreach ($sale as $x => $newSale) {
                        $bundle['dao_response']['sales'][$i]['seller'] = $seller;
                     }
               }
               
               $ControllerWshop = new ControllerWshop();
               $ControllerWshop->$function($bundle);

            break;

            case 'apiWshopGetClient':

                     /** $iddocumento = Key get data Wshop Scheme */
                     $column = $bundle['request']['column'];
                     $column_value = $bundle['request']['column_value'];
                     $sttipopessoa = $bundle['request']['sttipopessoa'];

               /** Wshop get data Client 
                  * =========================================================================
                  * -----------------------------------------------------------------------*/
               \BEGIN_TRANSACTION;
               $sql = "SELECT
                  /* ===================== */
                  /* |   Wshopp Scheme   | */
                  /* ===================== */
                     p.idpessoa,
                     p.cdchamada,         
                     p.stpessoa,          
                     p.nmpessoa,          
                     p.nmfantasia,        
                     p.nmendereco,        
                     p.nrlogradouro,      
                     p.nmbairro,          
                     p.nmcep,             
                     p.nmcidade,          
                     p.iduf,              
                     p.email,             
                     p.nrtelefone,        
                     p.nrtelcomercial,    
                     p.nrcodpager,
                     p.nrpager,
                     p.dtcadastro,        
                     p.cdempresa,
                     p.nrincrest_rg,
                     p.inscest_pfisica,
                     p.nrinscrmun,
                     p.dscomplemento,
                     p.idbairro,
                     p.idcidade,
                     p.nrcgc_cic
                  /* ===================== */

                     FROM wshop.pessoas AS p                     
                     WHERE p.$column = :column_value
                     AND LENGTH(p.idpessoa) > 2
                     AND p.stativo = :stativo
                     AND p.sttipopessoa = :sttipopessoa
                     LIMIT 1;";
                        
               $stmt = $this->db->prepare($sql);
               $stmt->bindValue(":column_value", $column_value);
               $stmt->bindValue(":stativo", 'S');
               $stmt->bindValue(":sttipopessoa", $sttipopessoa);
               $stmt->execute();
               $bundle['dao_response']['client'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               \FINAL_TRANSACTION;
               /** ------------------------------------------------------------------------
                  * ========================================================================*/
               $ControllerWshop = new ControllerWshop();
               $ControllerWshop->$function($bundle);
            break;

            case 'apiWshopGetClientPhone':

                     /** $iddocumento = Key get data Wshop Scheme */
                     $phone = $bundle['request']['phone'];

               /** Wshop get data Client  
                  * =========================================================================
                  * -----------------------------------------------------------------------*/
               \BEGIN_TRANSACTION;
               $sql = "SELECT
                  /* ===================== */
                  /* |   Wshopp Scheme   | */
                  /* ===================== */
                     p.idpessoa,
                     p.cdchamada,         
                     p.stpessoa,          
                     p.nmpessoa,          
                     p.nmfantasia,        
                     p.nmendereco,        
                     p.nrlogradouro,      
                     p.nmbairro,          
                     p.nmcep,             
                     p.nmcidade,          
                     p.iduf,              
                     p.email,             
                     p.nrtelefone,        
                     p.nrtelcomercial,    
                     p.nrcodpager,
                     p.nrpager,
                     p.dtcadastro,        
                     p.cdempresa,
                     p.nrincrest_rg,
                     p.inscest_pfisica,
                     p.nrinscrmun,
                     p.dscomplemento,
                     p.idbairro,
                     p.idcidade,
                     p.nrcgc_cic
                  /* ===================== */";

                     $condition = "FROM wshop.pessoas AS p                     
                     WHERE p.stpermissoes LIKE '%$phone%' ORDER BY dtcadastro DESC LIMIT 1;";
               //nrpager                
               $stmt = $this->db->prepare($sql.$condition);
               $stmt->execute();
               $bundle['dao_response']['client'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               $cli = $bundle['dao_response']['client'];
               \FINAL_TRANSACTION;
               /** ------------------------------------------------------------------------
                  * ========================================================================*/
               header('Content-Type: application/json');
               print_r(json_encode($cli));die;
               $ControllerWshop = new ControllerWshop();
               $ControllerWshop->$function($bundle);
            break;

            case 'apiWshopGetDataSale':

                     /** $iddocumento = Key get data Wshop Scheme */
                     $iddocumento = $bundle['request']['iddocumento'];

               /** Wshop get data Recebimento 
                  * =========================================================================
                  * -----------------------------------------------------------------------*/
               \BEGIN_TRANSACTION;
               $sql = "SELECT  r.nmtprecebimento, count(*), sum(f.vltitulo), r.idtprecebimento
                        FROM wshop.fluxo AS f 
                        INNER JOIN wshop.tprec AS r ON (r.idtprecebimento = f.idtipomovimento)            
                        WHERE f.iddocumento = :iddocumento
                        GROUP BY r.nmtprecebimento, r.idtprecebimento";
                        
               $stmt = $this->db->prepare($sql);
               $stmt->bindValue(":iddocumento", $iddocumento);
               $stmt->execute();
               $bundle['dao_response']['payment'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               \FINAL_TRANSACTION;
               /** ------------------------------------------------------------------------
                  * ========================================================================*/


               /** Wshop get data Seller 
                  * =========================================================================
                  * -----------------------------------------------------------------------*/
               \BEGIN_TRANSACTION;
               $sql = "SELECT p.idpessoa, p.nmpessoa
                        FROM wshop.comitem AS ci            
                        INNER JOIN wshop.pessoas AS p ON (p.idpessoa = ci.idpessoa)          
                        WHERE ci.iddocumento = :iddocumento LIMIT 1";
                        
               $stmt = $this->db->prepare($sql);
               $stmt->bindValue(":iddocumento", $iddocumento);
               $stmt->execute();
               $bundle['dao_response']['seller'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               \FINAL_TRANSACTION;
               /** ------------------------------------------------------------------------
                  * ========================================================================*/


               /** Wshop get data Client 
                  * =========================================================================
                  * -----------------------------------------------------------------------*/
               \BEGIN_TRANSACTION;
               /* ======================================================================== */
               $sql = "SELECT 
                  /* ============================================== */
                  /* |    Wshopp Scheme   |     CBapp Scheme      | */
                  /* ============================================== */
                     d.idpessoa,          /*     idpessoa           */
                     p.cdchamada,         /*     cdchamada          */
                     p.stpessoa,          /*     stpessoa           */
                     p.nmpessoa,          /*     nmpessoa           */
                     p.nmfantasia,        /*     nmfantasia         */
                     p.nmendereco,        /*     nmendereco         */
                     p.nrlogradouro,      /*     nrlogradouro       */
                     p.nmbairro,          /*     nmbairro           */
                     p.nmcep,             /*     nmcep              */
                     p.nmcidade,          /*     nmcidade           */
                     p.iduf,              /*     iduf               */
                     p.email,             /*     email              */
                     p.nrpager,           /*     nrpager            */
                     p.nrtelefone,        /*     nrtelefone         */
                     p.nrtelcomercial,    /*     nrtelcomercial     */
                     p.nrcodpager,        /*     nrcodpager         */
                     p.dtcadastro,        /*     dtcadastro         */
                     p.cdempresa,         /*     cdempresa          */     
                     p.nrincrest_rg,      /*     nrincrest_rg       */     
                     p.inscest_pfisica,   /*     inscest_pfisica    */     
                     p.nrinscrmun,        /*     nrinscrmun         */      
                     p.dscomplemento,     /*     dscomplemento      */
                     p.nrcgc_cic
                  /* ============================================== */
                     FROM wshop.pessoas AS p            
                     INNER JOIN wshop.documen AS d ON (d.idpessoa = p.idpessoa)          
                     WHERE d.iddocumento = :iddocumento LIMIT 1";
                  /* =========================================================== */
                  
               $stmt = $this->db->prepare($sql);
               $stmt->bindValue(":iddocumento", $iddocumento);
               $stmt->execute();
               $bundle['dao_response']['client'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               \FINAL_TRANSACTION;
               /** ------------------------------------------------------------------------
                  * ========================================================================*/


               /** Wshop get data Address 
                  * =========================================================================
                  * -----------------------------------------------------------------------*/
               \BEGIN_TRANSACTION;
               /* ======================================================================== */
               $sql = "SELECT 
                  /* ================================================ */
                  /* |    Wshopp Scheme     |     CBapp Scheme      | */
                  /* ================================================ */            
                     p.nmendereco,          /*  address_nmendereco    */
                     p.nmbairro,            /*  address_nmbairro      */
                     p.nmcep,               /*  address_nmcep         */
                     p.nmcidade,            /*  address_nmcidade      */
                     p.iduf,                /*  address_iduf          */
                     p.nrlogradouro,        /*  address_nrlogradouro  */
                     p.dscomplemento        /*  dscomplemento         */
                  /* ================================================ */
                     FROM wshop.pessoas AS p
                     INNER JOIN wshop.documen AS d ON (d.idpessoa = p.idpessoa)
                     WHERE d.iddocumento = :iddocumento LIMIT 1";
                  /* =========================================================== */
                  
               $stmt = $this->db->prepare($sql);
               $stmt->bindValue(":iddocumento", $iddocumento);
               $stmt->execute();
               $bundle['dao_response']['address'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               \FINAL_TRANSACTION;
               /** ------------------------------------------------------------------------
                  * ========================================================================*/

               /** Wshop get data Item 
                * =========================================================================
               * -----------------------------------------------------------------------*/
               \BEGIN_TRANSACTION;
               /* ======================================================================== */
               $sql = "SELECT         
                  /* ================================================ */
                  /* |    Wshopp Scheme     |     CBapp Scheme      | */
                  /* ================================================ */
                     i.iddocumentoitem,     /*   iddocumentoitem      */
                     i.iddocumento,         /*   iddocumento          */
                     i.iddetalhe,           /*   iddetalhe            */
                     i.idoperacao,          /*   idoperacao           */
                     i.idproduto,           /*   idproduto            */
                     p.idgrupo,             /*   idgrupo              */
                     p.cdchamada,           /*   cdchamada            */
                     c.dsitemcomplementar,  /*   dsitemcomplementar   */
                     p.nmproduto,           /*   nmproduto            */
                     g.cdgrupo,             /*   cdgrupo              */
                     g.nmgrupo,             /*   nmgrupo              */
                     d.idfamilia,           /*   idfamilia            */
                     f.dsfamilia,           /*   dsfamilia            */
                     i.qtitem,              /*   qtitem               */
                     i.vlitem,              /*   vlitem               */
                     i.vlcusto,             /*   vlcusto              */
                     i.vlunitario,          /*   vlunitario           */
                     i.vlmovimento,         /*   vlmovimento          */
                     cp.dscodigo,           /*   dscodigo             */
                     i.vldesconto           /*   vldesconto           */
                  /* ================================================ */
                     FROM wshop.docitem AS i

                     INNER JOIN wshop.produto AS p ON (p.idproduto = i.idproduto)
                     INNER JOIN wshop.grupo   AS g ON (g.idgrupo   = p.idgrupo)
                     INNER JOIN wshop.detalhe AS d ON (d.iddetalhe = i.iddetalhe)
                     INNER JOIN wshop.familia AS f ON (f.idfamilia = d.idfamilia)
                     INNER JOIN wshop.codigos AS cp ON (cp.idproduto = p.idproduto and cp.tpcodigo = 'Personalizado')
                     INNER JOIN wshop.cplitem AS c ON (c.iddocumentoitem = i.iddocumentoitem)
                     
                     WHERE i.iddocumento = :iddocumento";
                  /* =========================================================== */
                  
               $stmt = $this->db->prepare($sql);
               $stmt->bindValue(":iddocumento", $iddocumento);
               $stmt->execute();
               $bundle['dao_response']['item'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               \FINAL_TRANSACTION;
               /** ------------------------------------------------------------------------
                  * ========================================================================*/
               


               /** Wshop get data NFCE
                * ===========================================================================
               * --------------------------------------------------------------------------*/
               \BEGIN_TRANSACTION;
               /* ======================================================================== */
               $sql = "SELECT 
               /* ====================================================== */
               /* |    Wshopp Scheme         |      CBapp Scheme       | */
               /* ====================================================== */  
                  nfce.idnfce,               /*     idnfce               */
                  nfce.iddocumento,          /*     iddocumento          */
                  nfce.nrnotafiscal,         /*     nfce_nrrnotafiscal   */
                  nfce.serie,                /*     nfce_serie           */
                  nfce.chaveacesso,          /*     nfce_chaveacesso     */
                  nfce.statusnfce,           /*     nfce_statusnfce      */
                  nfce.cdretorno,            /*     nfce_cdretorno       */
                  nfce.dsretorno,            /*     nfce_dsretorno       */
                  nfce.protocolo,            /*     nfce_protocolo       */
                  nfce.dtemissao,            /*     nfce_dtemissao       */
                  nfce.cfop,                 /*     nfce_cfop            */
                  nfce.vltotal,              /*     nfce_vltotal         */
                  nfce.vldesconto            /*     nfce_vldesconto      */
               /* =================================================== */
                  FROM wshop.documento_nfce AS nfce
                  WHERE nfce.iddocumento = :iddocumento LIMIT 1";
               /* =========================================================== */
                  
               $stmt = $this->db->prepare($sql);
               $stmt->bindValue(":iddocumento", $iddocumento);
               $stmt->execute();
               $bundle['dao_response']['nfce'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               if(count($bundle['dao_response']['nfce']) > 0){
                     $idnfce = $bundle['dao_response']['nfce'][0]['idnfce'];
               }
               \FINAL_TRANSACTION;
               /** ---------------------------------------------------------------------------
                  * ===========================================================================*/

               /** Wshop get data NFE
                * ===========================================================================
               * --------------------------------------------------------------------------*/
               \BEGIN_TRANSACTION;
               /* ======================================================================== */
               $sql = "SELECT 
               /* ===================================================== */
               /* |    Wshopp Scheme        |      CBapp Scheme       | */
               /* ===================================================== */  
                  nfe.idnfe,                /*     idnfe                */
                  nfe.iddocumento,          /*     iddocumento          */
                  nfe.nrnotafiscal,         /*     nfce_nrrnotafiscal   */
                  nfe.serie,                /*     nfce_serie           */
                  nfe.chaveacesso,          /*     nfce_chaveacesso     */
                  nfe.statusnfe,            /*     nfce_statusnfce      */
                  nfe.cdretorno,            /*     nfce_cdretorno       */
                  nfe.dsretorno,            /*     nfce_dsretorno       */
                  nfe.protocolo,            /*     nfce_protocolo       */
                  nfe.dtemissao,            /*     nfce_dtemissao       */
                  nfe.cfop,                 /*     nfce_cfop            */
                  nfe.vltotal,              /*     nfce_vltotal         */
                  nfe.vldesconto            /*     nfce_vldesconto      */
               /* =================================================== */
                  FROM wshop.documento_nfe AS nfe
                  WHERE nfe.iddocumento = :iddocumento LIMIT 1";
               /* =========================================================== */
                  
               $stmt = $this->db->prepare($sql);
               $stmt->bindValue(":iddocumento", $iddocumento);
               $stmt->execute();
               $bundle['dao_response']['nfe'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               if(count($bundle['dao_response']['nfe']) > 0){
                     $idnfe = $bundle['dao_response']['nfe'][0]['idnfe'];
               }
               \FINAL_TRANSACTION;
               /** ---------------------------------------------------------------------------
                  * ===========================================================================*/

                  
               /** Wshop get data Documen 
                * ===========================================================================
               * --------------------------------------------------------------------------*/
               \BEGIN_TRANSACTION;
               /* ======================================================================== */
               $sql = "SELECT 
               /* =================================================== */
               /* |    Wshopp Scheme       |     CBapp Scheme       | */
               /* =================================================== */  
                  d.idpessoa,             /*     idpessoa             */
                  d.iddocumento,          /*     iddocumento          */
                  d.idpessoa,             /*     idpessoa             */
                  d.cdempresa,            /*     cdempresa            */
                  d.dtemissao,            /*     dtemissao            */
                  d.cdespecie,            /*     cdespecie            */
                  d.cdseriesubserie,      /*     cdseriesubserie      */
                  d.nrdocumento,          /*     nrdocumento          */
                  d.stdocumentocancelado, /*     stdocumentocancelado */
                  d.tpdocumento,          /*     tpdocumento          */
                  d.tpoperacao,           /*     tpoperacao           */
                  d.tpoperacao,           /*     tpoperacao           */
                  d.idterminal,           /*     idterminal           */
                  d.hrreferencia,         /*     hrreferencia         */
                  d.usuario,              /*     usuario              */
                  d.idnfe,                /*     idnfe                */
                  d.vltotal,              /*     vltotal              */
                  d.idsituacaodoc         /*     idsituacaodoc        */
               /* =================================================== */
                  FROM wshop.documen AS d
                  WHERE d.iddocumento = :iddocumento LIMIT 1";
               /* =========================================================== */
                  
               $stmt = $this->db->prepare($sql);
               $stmt->bindValue(":iddocumento", $iddocumento);
               $stmt->execute();
               $bundle['dao_response']['documen'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               if(isset($idnfce)){           
                  $bundle['dao_response']['documen'][0]['idnfce'] = $idnfce;
               }
               if(isset($idnfe)){           
                  $bundle['dao_response']['documen'][0]['idnfe'] = $idnfe;
               }
               \FINAL_TRANSACTION;
               /** ---------------------------------------------------------------------------
                  * ===========================================================================*/

               $ControllerWshop = new ControllerWshop();
               $ControllerWshop->$function($bundle);
            break;

            case 'apiWshopListProduct':

               /** Wshop get list Product
                * =========================================================================
               * -----------------------------------------------------------------------*/
               \BEGIN_TRANSACTION;
               /* ======================================================================== */
               $sql = "SELECT         
                  /* ================================================ */
                  /* |    Wshopp Scheme     |     CBapp Scheme      | */
                  /* ================================================ */
                     p.idproduto,           /*   idproduto            */
                     p.idgrupo,             /*   idgrupo              */
                     p.cdchamada,           /*   cdchamada            */
                     p.nmproduto,           /*   nmproduto            */
                     g.cdgrupo,             /*   cdgrupo              */
                     g.nmgrupo,             /*   nmgrupo              */
                     d.idfamilia,           /*   idfamilia            */
                     d.vlprecocusto,        /*   vlprecocusto         */
                     d.vlprecovenda,        /*   vlprecovenda         */
                     d.pesoliquido,         /*   pesoliquido          */
                     cp.dscodigo,           /*   dscodigo             */
                     f.dsfamilia            /*   dsfamilia            */
                     /*i.qtitem,                 qtitem               */
                     /*i.vlitem,                 vlitem               */
                     /*i.vlcusto,                vlcusto              */
                     /*i.vlunitario,             vlunitario           */
                     /*i.vlmovimento,            vlmovimento          */
                     /*i.vldesconto              vldesconto           */
                  /* ================================================ */
                     FROM wshop.produto AS p

                     INNER JOIN wshop.grupo   AS g ON (g.idgrupo   = p.idgrupo)
                     INNER JOIN wshop.detalhe AS d ON (d.idproduto = p.idproduto)
                     INNER JOIN wshop.familia AS f ON (f.idfamilia = d.idfamilia)
                     INNER JOIN wshop.codigos AS cp ON (cp.idproduto = p.idproduto and cp.tpcodigo = 'Personalizado')
                     
                     WHERE p.stativo = 'S'
                     /*AND (g.cdgrupo = ('000001')) BATERIA AUTOMOTIVA*/
                     /*OR  (g.cdgrupo = ('000002')) BATERIA ESTACIONARIA*/
                     /*OR  (g.cdgrupo = ('000003')) BATERIA MOTO*/
                     /*OR  (g.cdgrupo = ('000005')) SERVIÇOS ELÉTRICOS*/
                     /*OR  (g.cdgrupo = ('000006')) BATERIA NAUTICA*/
                     /*OR  (g.cdgrupo = ('000007')) BATERIA FROTA*/
                     /*OR  (g.cdgrupo = ('000014')) TERMINAIS DE BATERIA*/
                     ";
                  /* =========================================================== */

               $stmt = $this->db->prepare($sql);
               $stmt->execute();
               $bundle['dao_response']['product'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               \FINAL_TRANSACTION;
               /** ------------------------------------------------------------------------
                  * ========================================================================*/

               $ControllerWshop = new ControllerWshop();
               $ControllerWshop->$function($bundle);
            break;

            case 'apiGetPagamentoCombo':

               \BEGIN_TRANSACTION;
               $sql = "SELECT r.idtprecebimento, r.cdtiporec, r.nr_maximoparcelamentosadmcartao, r.nmtprecebimento
                        FROM wshop.tprec AS r ORDER BY r.nmtprecebimento
               ";

               $stmt = $this->db->prepare($sql);
               $stmt->execute();
               $bundle['dao_response']['pagamento'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
               \FINAL_TRANSACTION;

               $ControllerWshop = new ControllerWshop();
               $ControllerWshop->$function($bundle);
            break;

            case 'apiCheckClientLocalExists':

                  $client = $bundle['request'];

                  if(strlen($client['idpessoa']) > 5){

                        $sql = "SELECT idpessoa, dtcadastro FROM wshop.pessoas AS p
                           WHERE p.cdchamada = :cdchamada 
                           AND p.idpessoa = :idpessoa
                           AND p.stativo = 'S'
                           ORDER BY p.dtultimacompra DESC LIMIT 1;
                        ";
                        \BEGIN_TRANSACTION;
                        $stmt = $this->db->prepare($sql);
                        $stmt->bindValue(":cdchamada", $client['cdchamada']);
                        $stmt->bindValue(":idpessoa", $client['idpessoa']);
                        $stmt->execute();
                        $return =  $stmt->fetchAll(\PDO::FETCH_ASSOC);
                        $count = $stmt->rowCount();
                        \FINAL_TRANSACTION;

                  } else {

                        $sql = "SELECT idpessoa, dtcadastro FROM wshop.pessoas AS p
                           WHERE p.cdchamada = :cdchamada 
                           AND p.stativo = 'S'
                           ORDER BY p.dtcadastro DESC LIMIT 1;
                        ";
                        \BEGIN_TRANSACTION;
                        $stmt = $this->db->prepare($sql);
                        $stmt->bindValue(":cdchamada", $client['cdchamada']);
                        $stmt->execute();
                        $return =  $stmt->fetchAll(\PDO::FETCH_ASSOC);
                        $count = $stmt->rowCount();
                        \FINAL_TRANSACTION;
                  }
                  

                  //header('Content-Type: application/json');
                  //print_r(json_encode($client)); die;

                  if($count):
                        $client['dao_response_local']['idpessoa'] = $return[0]['idpessoa'];
                        $client['dao_response_local']['dtcadastro'] = $return[0]['dtcadastro'];
                        $client['dao_response_local']['status_exist'] = true;
                     return $client;
                  else:
                     $client['dao_response_local']['status_exist'] = false;
                     return $client;
                  endif;
            break;

            
            case 'apiWshopGetAddress':

               $addressType = $bundle['request']['addressType'];

               switch ($addressType) {
                  
                  case 'city':
                     $sql = "SELECT DISTINCT 
                     cep.idcidade, 
                     cid.nmcidade 
      
                     FROM wshop.cep AS cep
      
                     INNER JOIN wshop.cidade AS cid ON(cid.idcidade = cep.idcidade)
      
                     WHERE cep.cduf = :cduf 
                     AND cid.cdpaisbacen = '1058' 
                     ORDER BY cid.nmcidade
                     ";
                     \BEGIN_TRANSACTION;
                     $stmt = $this->db->prepare($sql);
                     $stmt->bindValue(":cduf", $bundle['request']['iduf']);
                     $stmt->execute();
                     $bundle['dao_response']['address'] =  $stmt->fetchAll(\PDO::FETCH_ASSOC);
                     $count = $stmt->rowCount();
                     \FINAL_TRANSACTION;
      
                     if($count):
                           $bundle['dao_response']['status_exist'] = true;
                        return $bundle;
                     else:
                        $bundle['dao_response']['status_exist'] = false;
                        return $bundle;
                     endif;
                  break;                  
                  
                  case 'district':
                     $sql = "SELECT DISTINCT 
                     cep.idbairro, 
                     bai.nmbairro 
                     
                     FROM wshop.cep AS cep

                     INNER JOIN wshop.bairro AS bai ON(bai.idbairro = cep.idbairro)

                     WHERE cep.cduf = :cduf
                     AND cep.idcidade = :idcidade
                     ORDER BY bai.nmbairro
                     ";

                     \BEGIN_TRANSACTION;
                     $stmt = $this->db->prepare($sql);
                     $stmt->bindValue(":cduf", $bundle['request']['iduf']);
                     $stmt->bindValue(":idcidade", $bundle['request']['idcidade']);
                     $stmt->execute();
                     $bundle['dao_response']['address'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
                     $count = $stmt->rowCount();
                     \FINAL_TRANSACTION;
      
                     if($count):
                           $bundle['dao_response']['status_exist'] = true;
                        return $bundle;
                     else:
                        $bundle['dao_response']['status_exist'] = false;
                        return $bundle;
                     endif;
                  break;
                  
                  case 'address':
                     $sql = "SELECT DISTINCT 
                     cep.cdcep, 
                     cep.nmlogradouro

                     FROM wshop.cep AS cep

                     INNER JOIN wshop.cidade AS cid ON(cid.idcidade = cep.idcidade)

                     WHERE cid.cdpaisbacen = '1058' 
                     AND cep.cduf = :cduf
                     AND cep.idcidade = :idcidade
                     AND cep.idbairro = :idbairro
                     /*AND cep.nmlogradouro LIKE :nmlogradouro*/
                     ";

                     \BEGIN_TRANSACTION;
                     $stmt = $this->db->prepare($sql);
                     $stmt->bindValue(":cduf", $bundle['request']['iduf']);
                     $stmt->bindValue(":idcidade", $bundle['request']['idcidade']);
                     $stmt->bindValue(":idbairro", $bundle['request']['idbairro']);
                     //$stmt->bindValue(":idcidade", $bundle['request']['idcidade']);
                     //$stmt->bindValue(":nmlogradouro", '%'.$bundle['request']['nmlogradouro'].'%');
                     $stmt->execute();
                     $bundle['dao_response']['address'] = $stmt->fetchAll(\PDO::FETCH_ASSOC);
                     $count = $stmt->rowCount();
                     \FINAL_TRANSACTION;
      
                     if($count):
                           $bundle['dao_response']['status_exist'] = true;
                        return $bundle;
                     else:
                        $bundle['dao_response']['status_exist'] = false;
                        return $bundle;
                     endif;
                  break;
                                    
                  default:
                     $bundle['dao_response']['status_exist'] = false;
                     return $bundle;
                  break;
               }

            break;

            case 'apiWshopGetAddressCep':
                  
                  $sql = "SELECT
                  cep.idcidade, 
                  cep.cduf, 
                  cep.idbairro, 
                  cep.nmlogradouro,
                  cid.nmcidade,
                  bai.nmbairro

                  FROM wshop.cep AS cep

                  LEFT JOIN wshop.cidade AS cid ON (cep.idcidade = cid.idcidade)
                  LEFT JOIN wshop.bairro AS bai ON (cep.idbairro = bai.idbairro)
                  
                  WHERE cep.cdcep = :cep
                  ";
                  \BEGIN_TRANSACTION;
                  $stmt = $this->db->prepare($sql);
                  $stmt->bindValue(":cep", $bundle['request']['nmcep']);
                  $stmt->execute();
                  $bundle['dao_response']['address'] =  $stmt->fetchAll(\PDO::FETCH_ASSOC);
                  $count = $stmt->rowCount();
                  \FINAL_TRANSACTION;

                  //header('Content-Type: application/json');
                  //print_r(json_encode($bundle)); die;

                  if($count):
                        $bundle['dao_response']['status_exist'] = true;
                     return $bundle;
                  else:
                     $bundle['dao_response']['status_exist'] = false;
                     return $bundle;
                  endif;

            break;

         }

   }

   public function update($bundle){
      //print_r(json_encode($bundle));die;
      $function = $bundle['request']['function'];
      switch ($function){

         case 'apiUpdateClientLocal':
         $client = $bundle['request']['client'];
            
            //abort update consumidor final
            if($client['cdchamada'] == '900000001'){
               $client['dao_response_local']['status_update'] = true;
               return $client; die;
            } 

                  if(strlen($client['cdchamada']) > 11): 
                     $client['nrincrest_rg'] = $client['inscestadual'];
                  else:
                     $client['nrincrest_rg'] = $client['rg'];
                  endif;         
                  
                  //DateUpdate
                  $dtalteracao = date('Y-m-d H:i:s');         

                  $dataUpdate =
                  [
                     'nmpessoa'           => mb_strtoupper($client['nmpessoa']),
                     'nmfantasia'         => mb_strtoupper($client['nmfantasia']),
                     'nmendereco'         => mb_strtoupper($client['nmendereco']),
                     'nrlogradouro'       => mb_strtoupper($client['nrlogradouro']),
                     'nmbairro'           => mb_strtoupper($client['nmbairro']),
                     'nmcep'              => $client['nmcep'],
                     'nmcidade'           => mb_strtoupper($client['nmcidade']),
                     'iduf'               => mb_strtoupper($client['iduf']),
                     'email'              => strtolower($client['email']),
                     'nrpager'            => $client['nrpager'],
                     'nrtelefone'         => $client['nrtelefone'],
                     'nrtelcomercial'     => $client['nrtelcomercial'],
                     'nrcodpager'         => $client['nrcodpager'],
                     'nrincrest_rg'       => $client['nrincrest_rg'],
                     'nrinscrmun'         => $client['nrinscrmun'],
                     'dscomplemento'      => mb_strtoupper($client['dscomplemento']),
                     'stpermissoes'       => mb_strtoupper($client['phones']),
                     'dtalteracao'        => mb_strtoupper($dtalteracao),
                     'idbairro'           => $client['idbairro'],
                     'idcidade'           => $client['idcidade'],
                     'stexp'              => mb_strtoupper('a'),
                     'idpessoa'           => $client['idpessoa']
                  ];

                  //header('Content-Type: application/json');
                  

                  \BEGIN_TRANSACTION;
                  $sql = "UPDATE wshop.pessoas SET
                     nmpessoa = :nmpessoa,
                     nmfantasia = :nmfantasia,
                     nmendereco = :nmendereco,
                     nrlogradouro = :nrlogradouro,
                     nmbairro = :nmbairro,
                     nmcep = :nmcep,
                     nmcidade = :nmcidade,
                     iduf = :iduf,
                     email = :email,
                     nrpager = :nrpager,
                     nrtelefone = :nrtelefone,
                     nrtelcomercial = :nrtelcomercial,
                     nrcodpager = :nrcodpager,
                     nrincrest_rg = :nrincrest_rg,
                     nrinscrmun = :nrinscrmun,
                     dscomplemento = :dscomplemento,
                     stpermissoes = :stpermissoes,
                     dtalteracao = :dtalteracao,
                     idbairro = :idbairro,
                     idcidade = :idcidade,
                     stexp = :stexp
                  /* ============================================== */

                  WHERE idpessoa = :idpessoa

               ";

               $stmt = $this->db->prepare($sql);
               $stmt->execute($dataUpdate); 
               $result = $stmt->rowCount();   
               \FINAL_TRANSACTION;

               
               if($result):
                     $client['dao_response_local']['status_update'] = true;
                     return $client;
               else:
                     $client['dao_response_local']['status_update'] = false;
                     return $client;
                  endif;

         break;

         case 'updateDocumenAddSale':

         print_r(json_encode($bundle)); die;

         foreach ($bundle['request']['documen'] as $key => $doc) {

            $dataUpdate[$key] =
            [
               'idpedido'           => $bundle['request']['sale_id'],
               'stexp'              => ('A'),
               'iddocumento'        => $doc['iddocumento']
            ];

            $sql = "UPDATE wshop.documen SET
               idpedido = :idpedido,
               stexp = :stexp
               WHERE iddocumento = :iddocumento

            ";
            \BEGIN_TRANSACTION;
            $stmt = $this->db->prepare($sql);
            $stmt->execute($dataUpdate[$key]); 
            $result = $stmt->rowCount();   
            \FINAL_TRANSACTION;
        }

        $sql = " SELECT * FROM wshop.documen WHERE iddocumento = '01007EY21P'";

         \BEGIN_TRANSACTION;
         $stmt = $db->prepare($sql);
         $stmt->execute();
         $return =  $stmt->fetchAll(\PDO::FETCH_ASSOC);
         $count = $stmt->rowCount();
         \FINAL_TRANSACTION;

         print_r(json_encode($return)); die;

         break;
      
      }

   }

}
