<?php

namespace CBapp\View;

class View
{
    private $view;

    public function __construct($bundle)
    {
        /** Check Authentication ******************************************/
        if (!isset($_SESSION['CBappLog'])):
            $bundle['view'] = 'ViewAuthentication'; $bundle['theme'] = false;
        else:
            if($_SESSION['CBappLog'] != 'SIM'):
                $bundle['view'] = 'ViewAuthentication'; $bundle['theme'] = false;
            endif;
        endif;
        /******************************************************************/

        /** Passe view name for this->view
         *  + encapsulate extension .phtml
         */
        $this->view = $bundle['view'] . '.phtml';

        /** Check relative use theme */
        if (!isset($bundle['theme'])):
            $bundle['theme'] = true;
        endif;

        if (isset($bundle['theme']) and (!is_bool($bundle['theme']))):
            echo "<script>alert('ERROR: Attribute theme, must be boolean.');</script>";die;
        endif;

        if ($bundle['theme'] == false):
            /** Set view theme off */
            include $this->view;die;
        else:
            /** Set view theme on */
            $this->includeView($bundle);
        endif;
    }

    /** Set view theme on */
    private function includeView($bundle)
    {
        include 'template/TemplateIni.phtml';
        include $this->view;
        include 'template/TemplateEnd.phtml';
    }
}
