
$(document).ready(function () {
    comboStores();
    $('#combo-store').css('border-color', 'gray');
});

function prepareForm(fnc) {
    
    switch (fnc) {
        case 'create':
            $('#form')[0].reset();
            $('#title-modal').text('Cadastrar Dispositivo');
            $('#submit_form').text('CADASTRAR DISPOSITIVO');
            $('#submit_form').attr('onClick', 'apiCriateDevicePay()');
            $("#submit_form").attr('disabled', 'false');
            $('#payment_device_code').removeAttr('readonly');
            $('#function').attr('value', 'apiCreateStore');
            break;

        case 'update':
            $('#form')[0].reset();
            $('#title-modal').text('Alterar Dispositivo');
            $('#submit_form').text('ALTERAR DISPOSITIVO');
            $('#submit_form').attr('onClick', 'apiUpdateDevicePay()');
            $("#submit_form").attr('disabled', 'false');
            //$("#payment_device_code").attr('readonly', 'true');
            $("#combo-store").attr('onChange', 'checkForm()');
            $('#function').attr('value', 'apiUpdateDevicePay');
            $('#prepareUpdateForm').click();
            break;
    }
}

window.addEventListener('load', function () {
    loadListDevicePay();
})

function loadListDevicePay() {

    let tbody = id('tbody')
    let request = { function: 'apiListDevicePay' }
    $("#tbody").empty();

    CBappApi(request, function(response){
        response.forEach((devicePay, index) => {
                let tmpl = `<tr id="store-${devicePay.payment_device_id}" class="modal-trigger" data-modal="modal_device_pay" style="cursor: pointer;">
                            <td onclick="apiGetDevicePay('${devicePay.payment_device_id}','apiGetDevicePay')" id="td-payment-device-code-${devicePay.payment_device_id}">${devicePay.payment_device_code}</td>
                            <td onclick="apiGetDevicePay('${devicePay.payment_device_id}','apiGetDevicePay')" id="td-store-cdempresa-${devicePay.payment_device_id}">${devicePay.store_code}</td>
                            <td onclick="apiGetDevicePay('${devicePay.payment_device_id}','apiGetDevicePay')" id="td-payment-device-provider-${devicePay.payment_device_id}">${devicePay.payment_device_provider}</td>
                            <td onclick="apiGetDevicePay('${devicePay.payment_device_id}','apiGetDevicePay')" id="td-payment-device-status-${devicePay.payment_device_id}">${devicePay.payment_device_status}</td>
                        </tr>`
                tbody.innerHTML += tmpl
            })
    })
}

function apiCriateDevicePay() {

    let payment_device_code = id('payment_device_code').value
    let payment_device_provider = id('payment_device_provider').value
    let combo = id('combo-store')
    let store_code = combo.options[combo.selectedIndex].value
    let payment_device_status = $("input[id='payment_device_status']:checked").val(); if (payment_device_status != 'A') { payment_device_status = '' }
    let func = 'apiCriateDevicePay'    

    let request =
    {
        payment_device_code: payment_device_code,
        payment_device_provider: payment_device_provider,
        store_code: store_code,
        payment_device_status: payment_device_status,
        function: func
    }

    CBappApi(request, function(response){
        if (response.resMsg == 'ok:create') {
            id('modal-delete').click();
            toastMsg('Dispositivo cadastrado!')
            loadListDevicePay()
        }
        if (response.resMsg == 'error:duplicate') {                        
            toastMsg('ERROR: Dispositivo já cadastrado.')
        }
    })
}

function apiUpdateDevicePay() {

    $("#submit_form").attr('disabled', 'disabled');

    let payment_device_id = id('payment_device_id').value
    let payment_device_code = id('payment_device_code').value
    let payment_device_provider = id('payment_device_provider').value
    let combo = id('combo-store')
    let store_code = combo.options[combo.selectedIndex].value
    let payment_device_status = $("input[id='payment_device_status']:checked").val(); if (payment_device_status != 'A') { payment_device_status = '' }
    let func = 'apiUpdateDevicePay'    

    let request =
    {
        payment_device_id: payment_device_id,
        payment_device_code: payment_device_code,
        payment_device_provider: payment_device_provider,
        store_code: store_code,
        payment_device_status: payment_device_status,        
        function: func
    }
    
    CBappApi(request, function(response){
        if (response.resMsg == 'ok:update') {
                id('modal-delete').click();
                toastMsg('Alteração realizada!');
                data = request;
                $('#td-payment-device-code-' + data.payment_device_id).html(data.payment_device_code);
                $('#td-store-cdempresa-' + data.payment_device_id).html(data.store_code);
                $('#td-payment-device-provider-' + data.payment_device_id).html(data.payment_device_provider);
                $('#td-payment-device-status-' + data.payment_device_id).html(data.payment_device_status);

            } else {
                toastMsg('Erro no processo, tente mais tarde')
            }
    })    
}

function apiGetDevicePay(id, fnc) {
            
            prepareForm('update');
            let request = { id: id, function: fnc}
            
            CBappApi(request, function(response){
              let data = response

              //Set Data Form
              $('#payment_device_id').val(JSON.stringify(data.payment_device_id).replace(/"/g, ""))
              $('#payment_device_code').val(JSON.stringify(data.payment_device_code).replace(/"/g, ""))
              $('#payment_device_code').val(JSON.stringify(data.payment_device_code).replace(/"/g, ""))
              $('#payment_device_provider').val(JSON.stringify(data.payment_device_provider).replace(/"/g, ""))
              let sts = JSON.stringify(data.payment_device_status).replace(/"/g, "");              

              let loj = JSON.stringify(data.store_code).replace(/"/g, "");
              $('#combo-store').val(loj);

              if (sts == 'A') { $('#payment_device_status').prop('checked', true); }

              checkForm()

           })
}

function checkForm() {
    $('#submit_form').removeAttr('disabled');
/*
    $("#submit_form").attr('disabled', 'disabled');

    let user_first_name = $('#user_first_name').val();
    let user_last_name = $('#user_last_name').val();
    let user_phone = $('#user_phone').val();
    let user_email = $('#user_email').val();
    let user_pass = $('#user_pass').val();
    let user_confirm_pass = $('#user_confirm_pass').val();
    let user_status = $('#user_status').val();
    var user_store = $("#combo-store option:selected").val();

    if (user_first_name.length < 4 || user_last_name.length < 4 || user_phone.length < 10 || user_email.length < 10 || user_confirm_pass != user_pass || user_store == '--Selecione--') {

        $("#submit_form").attr('disabled', 'disabled');
        if (user_pass.lenght != '' & user_confirm_pass != '') {
            if (user_pass != user_confirm_pass) {
                toastMsg('Senhas não conferem.');
                $('#user_confirm_senha').fucus();
            }
        }

    } else {
        $("#submit_form").removeAttr('disabled');
    }*/
}