$(document).ready(function () {

    /** Search User ****/
    $("#search-user").on("keyup", function() {
        var value = $(this).val().toLowerCase();
        $("#tableList tr").filter(function() {
            $(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
        });
    });
    /*******************/

    /** Get Combos *************/
    comboStores();
    /***************************/

    //css atack *********************************
    let comboStore = $('#combo-store');
    comboStore.css('border-color', 'gray');
    //*******************************************/

    /** Mask Date *******************************************************/
    $(document).on('keydown', '[data-mask-for-date]', function (el) {
        var digit = el.key.replace(/\D/g, '');        
        var value = $(this).val().replace(/\D/g, '');        
        var size = value.concat(digit).length;        
        $(this).mask('00/00/0000');
    });
    /** END Mask Date ***************************************************/
});

function prepareForm(fnc) {
    switch (fnc) {
        case 'create_user':
            $('#actual_img').attr('src', '')
            $('#form_user')[0].reset();
            $('#title-modal').text('Cadastrar Usuário');
            $('#submit_user').text('CADASTRAR USUÁRIO');
            $('#submit_user').attr('onClick', 'apiCriateUser()');            
            $('#user_pass').attr('required', '');
            $('#user_confirm_pass').attr('required', '');
            $("#submit_user").attr('disabled', 'disabled');
            $("#combo-store").attr('onChange', 'checkForm()');
            $('#function').attr('value', 'createUser');
            break;

        case 'update_user':
            $('#actual_img').attr('src', '')
            $('#form_user')[0].reset();
            $('#title-modal').text('Alterar Usuário');
            $('#submit_user').text('ALTERAR USUÁRIO');
            $('#submit_user').attr('onClick', 'apiUpdateUser()');
            $('#user_pass').removeAttr('required');
            $('#user_pass').val("");
            $('#user_confirm_pass').val("");
            $('#user_confirm_pass').removeAttr('required');
            $("#submit_user").attr('disabled', 'disabled');
            $("#combo-store").attr('onChange', 'checkForm()');
            $('#function').attr('value', 'apiUpdateUser');
            $('#prepareUpdateForm').click();
            break;
    }
}

window.addEventListener('load', function () {
    loadListUser();
})

function loadListUser() {

    let tbody = id('tbody')
    let request = { function: 'apiListUser' }
    $("#tbody").empty();

    CBappApi(request, function(response){
        data = response
        data.forEach((user, index) => {
                let tmpl = `<tr id="user-${user.user_id}" class="modal-trigger" data-modal="modal_user" style="cursor: pointer;">
                            <td style="font-size: 1.5vh; text-align: left;" onclick="apiGetUser('${user.user_id}','apiGetUser')" id="td-user-first-name-${user.user_id}"><div style="margin-left: 4vh;">${user.user_first_name}</div></td>
                            <td style="font-size: 1.5vh;" onclick="apiGetUser('${user.user_id}','apiGetUser')" id="td-user-phone-${user.user_id}">${user.user_phone}</td>
                            <td style="font-size: 1.5vh;" onclick="apiGetUser('${user.user_id}','apiGetUser')" id="td-user-email-${user.user_id}">${user.user_email}</td>
                            <td style="font-size: 1.5vh;" onclick="apiGetUser('${user.user_id}','apiGetUser')" id="td-store-code-${user.user_id}">${user.store_code}</td>
                            <td style="font-size: 1.5vh;" onclick="apiGetUser('${user.user_id}','apiGetUser')" id="td-user-status-${user.user_id}">${user.user_status}</td>
                        </tr>`
                tbody.innerHTML += tmpl
            })
    })
}

function apiCriateUser() {
    
    $("#submit_user").attr('disabled', 'disabled');

    let user_id = id('user_id').value
    let user_first_name = id('user_first_name').value
    let user_phone = id('user_phone').value
    let user_ramal = id('user_ramal').value
    let user_email = id('user_email').value
    let user_pass = id('user_pass').value
    let user_confirm_pass = id('user_confirm_pass').value
    let user_date_birth = id('user_date_birth').value
    let user_document_cpf = id('user_document_cpf').value
    let combo = id('combo-store')
    let user_store = combo.options[combo.selectedIndex].value
    let user_roles_adm = $("input[id='user_roles_adm']:checked").val(); if (user_roles_adm != 1) { user_roles_adm = '' }
    let user_roles_tec = $("input[id='user_roles_tec']:checked").val(); if (user_roles_tec != 1) { user_roles_tec = '' }
    let user_roles_sup = $("input[id='user_roles_sup']:checked").val(); if (user_roles_sup != 1) { user_roles_sup = '' }
    let user_roles_ven = $("input[id='user_roles_ven']:checked").val(); if (user_roles_ven != 1) { user_roles_ven = '' }
    let user_status = $("input[id='user_status']:checked").val(); if (user_status != 'A') { user_status = '' }
    let func = 'apiCriateUser'
    let user_img_profile = $("#user_img_profile").prop("files")[0];

    let form_data = new FormData();
    form_data.append("user_first_name", user_first_name);
    form_data.append("user_phone", user_phone);
    form_data.append("user_ramal", user_ramal);
    form_data.append("user_email", user_email);
    form_data.append("user_pass", user_pass);
    form_data.append("user_confirm_pass", user_confirm_pass);
    form_data.append("user_date_birth", user_date_birth);
    form_data.append("user_document_cpf", user_document_cpf);
    form_data.append("store_code", user_store);
    form_data.append("administrator", user_roles_adm);
    form_data.append("seller", user_roles_ven);
    form_data.append("technical", user_roles_tec);
    form_data.append("supervisor", user_roles_sup);
    form_data.append("user_status", user_status);
    form_data.append("function", func);
    form_data.append("user_img_profile", user_img_profile);
    form_data.append("user_img_profile_used", '');
    form_data.append("user_id", ''); 

    /*let request =
    {
        user_first_name: user_first_name,
        user_phone: user_phone,
        user_ramal: user_ramal,
        user_email: user_email,
        user_pass: user_pass,
        user_confirm_pass: user_confirm_pass,
        user_date_birth: user_date_birth,
        user_document_cpf: user_document_cpf,
        store_code: user_store,
        administrator: user_roles_adm,
        seller: user_roles_ven,
        technical: user_roles_tec,
        supervisor: user_roles_sup,
        user_status: user_status,
        function: func,
        user_img_profile: user_img_profile,
        user_id: user_id
    }*/

    CBappApi(form_data, function(response){
        if (response.resMsg == 'ok:create') {
            id('modal-delete').click();
            toastMsg('Usuário cadastrado!')
            loadListUser()
        }
        if (response.resMsg == 'error:duplicate') {                        
            toastMsg('ERROR: E-mail já cadastrado.')
        }
    })
}

function apiUpdateUser() {

    let user_id = id('user_id').value
    let user_first_name = id('user_first_name').value
    let user_phone = id('user_phone').value
    let user_ramal = id('user_ramal').value
    let user_email = id('user_email').value
    let user_pass = id('user_pass').value
    let user_confirm_pass = id('user_confirm_pass').value
    let user_date_birth = id('user_date_birth').value
    let user_document_cpf = id('user_document_cpf').value
    let combo = id('combo-store')
    let user_store = combo.options[combo.selectedIndex].value
    let user_roles_adm = $("input[id='user_roles_adm']:checked").val(); if (user_roles_adm != 1) { user_roles_adm = '' }
    let user_roles_tec = $("input[id='user_roles_tec']:checked").val(); if (user_roles_tec != 1) { user_roles_tec = '' }
    let user_roles_sup = $("input[id='user_roles_sup']:checked").val(); if (user_roles_sup != 1) { user_roles_sup = '' }
    let user_roles_ven = $("input[id='user_roles_ven']:checked").val(); if (user_roles_ven != 1) { user_roles_ven = '' }
    let user_status = $("input[id='user_status']:checked").val(); if (user_status != 'A') { user_status = '' }
    let func = 'apiUpdateUser'
    let user_img_profile = $("#user_img_profile").prop("files")[0];
    let user_img_profile_used = $("#user_img_profile_used").val();

    let form_data = new FormData();
    form_data.append("user_first_name", user_first_name);
    form_data.append("user_phone", user_phone);
    form_data.append("user_ramal", user_ramal);
    form_data.append("user_email", user_email);
    form_data.append("user_pass", user_pass);
    form_data.append("user_confirm_pass", user_confirm_pass);
    form_data.append("user_date_birth", user_date_birth);
    form_data.append("user_document_cpf", user_document_cpf);
    form_data.append("store_code", user_store);
    form_data.append("administrator", user_roles_adm);
    form_data.append("seller", user_roles_ven);
    form_data.append("technical", user_roles_tec);
    form_data.append("supervisor", user_roles_sup);
    form_data.append("user_status", user_status);
    form_data.append("function", func);
    form_data.append("user_img_profile", user_img_profile);
    form_data.append("user_img_profile_used", user_img_profile_used);
    form_data.append("user_id", user_id);    

    CBappApi(form_data, function(response){
        if (response.resMsg == 'ok:update') {
            apiGetUser(user_id,'apiGetUser');
            //id('modal-delete').click();
            toastMsg('Usuário alterado!')
            loadListUser()
        }
        if (response.resMsg == 'error:update') {                        
            toastMsg('ERROR: Alteração não realizada, tente mais tarde');
        }
    })

}

function apiGetUser(id, fnc) {

            $('#actual_img').attr('src', '');

            prepareForm('update_user');
            let request = { id: id, function: fnc}
            
            CBappApi(request, function(response){
              let data = response

              //Set Data Form
              $('#user_id').val(data.user_id);
              $('#user_first_name').val(data.user_first_name);
              $('#user_phone').val(data.user_phone);
              $('#user_ramal').val(data.user_ramal);
              $('#user_email').val(data.user_email);
              $('#user_pass').val("")
              $('#user_confirm_pass').val("")
              $('#user_date_birth').val(formatDateBrl(data.user_date_birth));
              $('#user_img_profile_used').val(data.user_img_profile);
              $('#user_document_cpf').val(data.user_document_cpf);

              if(data.user_img_profile == null){
                $('#actual_img').attr('src', '../private/media/image/profile/user.png');
              } else {
                $('#actual_img').attr('src', '../private/media/image/profile/'+data.user_img_profile);
              }
              

              let adm = (data.administrator);
              let tec = (data.technical);
              let sup = (data.supervisor);
              let ven = (data.seller);
              let sts = (data.user_status);

              let loj = (data.store_code);
              $('#combo-store').val(loj);

              if (adm == 1) { $('#user_roles_adm').prop('checked', true); }
              if (tec == 1) { $('#user_roles_tec').prop('checked', true); }
              if (sup == 1) { $('#user_roles_sup').prop('checked', true); }
              if (ven == 1) { $('#user_roles_ven').prop('checked', true); }
              if (sts == 'A') { $('#user_status').prop('checked', true); }

              checkForm()

           })
}

function checkForm() {

    $("#submit_user").attr('disabled', 'disabled');

    let user_first_name = $('#user_first_name').val();
    let user_date_birth = $('#user_date_birth').val();
    let user_phone = $('#user_phone').val();
    let user_ramal = $('#user_ramal').val();
    let user_email = $('#user_email').val();
    let user_pass = $('#user_pass').val();
    let user_confirm_pass = $('#user_confirm_pass').val();
    let user_status = $('#user_status').val();
    var user_store = $("#combo-store option:selected").val();

    if (user_first_name.length < 4 || user_confirm_pass != user_pass || user_store == '--Selecione--') {

        $("#submit_user").attr('disabled', 'disabled');
        if (user_pass.lenght != '' & user_confirm_pass != '') {
            if (user_pass != user_confirm_pass) {
                toastMsg('Senhas não conferem.');
                $('#user_confirm_senha').fucus();
            }
        }

    } else {
        $("#submit_user").removeAttr('disabled');
    }
}